diff --git a/package/kernel/linux/modules/fs.mk b/package/kernel/linux/modules/fs.mk
index db753308eec0..79ba672967dc 100644
--- a/package/kernel/linux/modules/fs.mk
+++ b/package/kernel/linux/modules/fs.mk
@@ -206,10 +206,7 @@ define KernelPackage/fs-f2fs
   SUBMENU:=$(FS_MENU)
   TITLE:=F2FS filesystem support
   DEPENDS:= +kmod-crypto-hash +kmod-crypto-crc32 +!LINUX_4_19:kmod-nls-base
-  KCONFIG:= \
-	CONFIG_F2FS_FS \
-	CONFIG_F2FS_FS_POSIX_ACL=n \
-	CONFIG_F2FS_CHECK_FS=n
+  KCONFIG:=CONFIG_F2FS_FS
   FILES:=$(LINUX_DIR)/fs/f2fs/f2fs.ko
   AUTOLOAD:=$(call AutoLoad,30,f2fs,1)
 endef
diff --git a/target/linux/apm821xx/sata/config-default b/target/linux/apm821xx/sata/config-default
index 284ba04bb8f3..db2c5c8a307c 100644
--- a/target/linux/apm821xx/sata/config-default
+++ b/target/linux/apm821xx/sata/config-default
@@ -15,7 +15,6 @@ CONFIG_GENERIC_PHY=y
 CONFIG_SATA_DWC=y
 # CONFIG_SATA_DWC_DEBUG is not set
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_SCSI=y
 CONFIG_BLK_DEV_SD=y
diff --git a/target/linux/armvirt/config-4.19 b/target/linux/armvirt/config-4.19
index 945cf9189327..6dbc5aecfdda 100644
--- a/target/linux/armvirt/config-4.19
+++ b/target/linux/armvirt/config-4.19
@@ -55,7 +55,6 @@ CONFIG_DEBUG_BUGVERBOSE=y
 CONFIG_DTC=y
 CONFIG_EDAC_SUPPORT=y
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FAILOVER=y
 CONFIG_FIX_EARLYCON_MEM=y
diff --git a/target/linux/armvirt/config-5.4 b/target/linux/armvirt/config-5.4
index f2c43a3ff2fb..806de23964ad 100644
--- a/target/linux/armvirt/config-5.4
+++ b/target/linux/armvirt/config-5.4
@@ -68,7 +68,6 @@ CONFIG_DMA_REMAP=y
 CONFIG_DTC=y
 CONFIG_EDAC_SUPPORT=y
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FAILOVER=y
 CONFIG_FIX_EARLYCON_MEM=y
diff --git a/target/linux/generic/config-4.19 b/target/linux/generic/config-4.19
index 3de757ae2661..6f4478f18e14 100644
--- a/target/linux/generic/config-4.19
+++ b/target/linux/generic/config-4.19
@@ -1403,6 +1403,7 @@ CONFIG_EXTRA_TARGETS=""
 # CONFIG_EXYNOS_VIDEO is not set
 # CONFIG_EZCHIP_NPS_MANAGEMENT_ENET is not set
 # CONFIG_EZX_PCAP is not set
+# CONFIG_F2FS_CHECK_FS is not set
 # CONFIG_F2FS_FAULT_INJECTION is not set
 # CONFIG_F2FS_FS is not set
 # CONFIG_F2FS_FS_ENCRYPTION is not set
diff --git a/target/linux/imx6/config-4.19 b/target/linux/imx6/config-4.19
index d38ebe10e43b..8435ece397b1 100644
--- a/target/linux/imx6/config-4.19
+++ b/target/linux/imx6/config-4.19
@@ -188,7 +188,6 @@ CONFIG_EXT4_FS_SECURITY=y
 CONFIG_EXTCON=y
 CONFIG_EXTRA_FIRMWARE="imx/sdma/sdma-imx6q.bin"
 CONFIG_EXTRA_FIRMWARE_DIR="firmware"
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FEC=y
 CONFIG_FIXED_PHY=y
diff --git a/target/linux/malta/config-4.19 b/target/linux/malta/config-4.19
index 3cb1b34eaecf..862f869704b0 100644
--- a/target/linux/malta/config-4.19
+++ b/target/linux/malta/config-4.19
@@ -93,7 +93,6 @@ CONFIG_DTC=y
 CONFIG_DUMMY_CONSOLE=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FS_IOMAP=y
 CONFIG_FS_MBCACHE=y
diff --git a/target/linux/mediatek/mt7623/config-4.19 b/target/linux/mediatek/mt7623/config-4.19
index 01c96b1f0a86..843497227919 100644
--- a/target/linux/mediatek/mt7623/config-4.19
+++ b/target/linux/mediatek/mt7623/config-4.19
@@ -173,7 +173,6 @@ CONFIG_EDAC_SUPPORT=y
 CONFIG_EINT_MTK=y
 CONFIG_ELF_CORE=y
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
diff --git a/target/linux/mvebu/config-4.19 b/target/linux/mvebu/config-4.19
index 5dbbb5956227..7a13cd50c9dc 100644
--- a/target/linux/mvebu/config-4.19
+++ b/target/linux/mvebu/config-4.19
@@ -176,7 +176,6 @@ CONFIG_EDAC_ATOMIC_SCRUB=y
 CONFIG_EDAC_SUPPORT=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FIXED_PHY=y
 CONFIG_FIX_EARLYCON_MEM=y
diff --git a/target/linux/octeon/config-4.19 b/target/linux/octeon/config-4.19
index 49ecd3d43a0d..3385271beda0 100644
--- a/target/linux/octeon/config-4.19
+++ b/target/linux/octeon/config-4.19
@@ -73,7 +73,6 @@ CONFIG_EDAC_ATOMIC_SCRUB=y
 CONFIG_EDAC_SUPPORT=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FAT_FS=y
 CONFIG_FIXED_PHY=y
diff --git a/target/linux/omap/config-4.19 b/target/linux/omap/config-4.19
index db37a89e5bb2..3ecabead882a 100644
--- a/target/linux/omap/config-4.19
+++ b/target/linux/omap/config-4.19
@@ -238,7 +238,6 @@ CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
 CONFIG_EXTCON_PALMAS=y
 CONFIG_EXTCON_USB_GPIO=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FANOTIFY=y
 CONFIG_FAT_FS=y
diff --git a/target/linux/sunxi/config-4.19 b/target/linux/sunxi/config-4.19
index 5f682d2c51b9..e3ac9f4f2dd0 100644
--- a/target/linux/sunxi/config-4.19
+++ b/target/linux/sunxi/config-4.19
@@ -170,7 +170,6 @@ CONFIG_ELF_CORE=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FAT_FS=y
 CONFIG_FB=y
diff --git a/target/linux/tegra/config-4.19 b/target/linux/tegra/config-4.19
index 86299a719689..20eead79cebb 100644
--- a/target/linux/tegra/config-4.19
+++ b/target/linux/tegra/config-4.19
@@ -195,7 +195,6 @@ CONFIG_EDAC_SUPPORT=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FB=y
 CONFIG_FB_CFB_COPYAREA=y
diff --git a/target/linux/tegra/config-5.4 b/target/linux/tegra/config-5.4
index 6baedf035dc6..f6eef50e75fa 100644
--- a/target/linux/tegra/config-5.4
+++ b/target/linux/tegra/config-5.4
@@ -210,7 +210,6 @@ CONFIG_EDAC_SUPPORT=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FB=y
 CONFIG_FB_CFB_COPYAREA=y
diff --git a/target/linux/x86/config-4.19 b/target/linux/x86/config-4.19
index 412fdf900b69..fad10dfef4fc 100644
--- a/target/linux/x86/config-4.19
+++ b/target/linux/x86/config-4.19
@@ -128,7 +128,6 @@ CONFIG_EDAC_SUPPORT=y
 # CONFIG_EDD is not set
 # CONFIG_EUROTECH_WDT is not set
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 # CONFIG_F71808E_WDT is not set
 CONFIG_FIRMWARE_MEMMAP=y
diff --git a/target/linux/x86/config-5.4 b/target/linux/x86/config-5.4
index 66cca9600554..83d9cf2e0509 100644
--- a/target/linux/x86/config-5.4
+++ b/target/linux/x86/config-5.4
@@ -145,7 +145,6 @@ CONFIG_EFI_EARLYCON=y
 # CONFIG_EISA is not set
 # CONFIG_EUROTECH_WDT is not set
 CONFIG_EXT4_FS=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 # CONFIG_F71808E_WDT is not set
 CONFIG_FIRMWARE_MEMMAP=y
diff --git a/target/linux/zynq/config-4.19 b/target/linux/zynq/config-4.19
index 86033b031a9c..1581521d89b4 100644
--- a/target/linux/zynq/config-4.19
+++ b/target/linux/zynq/config-4.19
@@ -192,7 +192,6 @@ CONFIG_ELF_CORE=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FB=y
 CONFIG_FB_CFB_COPYAREA=y
diff --git a/target/linux/zynq/config-5.4 b/target/linux/zynq/config-5.4
index 090846036e97..5b7b0ebfb32e 100644
--- a/target/linux/zynq/config-5.4
+++ b/target/linux/zynq/config-5.4
@@ -203,7 +203,6 @@ CONFIG_ELF_CORE=y
 CONFIG_ENABLE_MUST_CHECK=y
 CONFIG_EXT4_FS=y
 CONFIG_EXTCON=y
-# CONFIG_F2FS_CHECK_FS is not set
 CONFIG_F2FS_FS=y
 CONFIG_FB=y
 CONFIG_FB_CFB_COPYAREA=y